

#include <avr/pgmspace.h>
#include <EEPROM.h>
#include "mpguino_conf.h"

#if( SLEEP_CFG == 3 )
#include <avr/sleep.h>
#endif
#include <SPI.h>
//#include <SD.h>


#include <TFT_ILI9341.h>
#define RED2RED 0
#define GREEN2GREEN 1
#define BLUE2BLUE 2
#define BLUE2RED 3
#define GREEN2RED 4
#define RED2GREEN 5
#include <URTouch.h>

TFT_ILI9341 tft = TFT_ILI9341();       // Invoke custom library

#define HX8357_GREY 0x2104 // Dark grey 16 bit colour

uint32_t runTime = -99999;



unsigned long MAXLOOPLENGTH;            // see if we are overutilizing the CPU      

//for display computing
static unsigned long tmp1[2];
static unsigned long tmp2[2];
static unsigned long tmp3[2];





//middle button cycles through these brightness settings      

volatile unsigned long timer2_overflow_count;





#include "mpguino.h";
//#include "lcd.h"

















/* --- End Global Variable Declarations ---------------------- */


/*** Set up the Events ***
 * We have our own ISR for timer2 which gets called about once a millisecond.
 * So we define certain event functions that we can schedule by calling addEvent
 * with the event ID and the number of milliseconds to wait before calling the event. 
 * The milliseconds is approximate.
 * 
 * Keep the event functions SMALL!!!  This is an interrupt!
 * 
 */
//event functions



int tempscreen;
int touchorient;
int cp;
URTouch  myTouch(11, 10, 9, 8, 7);
int screenstate=250;
int menuitem;
long tempfill;
long fueladd=0;
long mpg;
long mpgmax;
int refresher;
int reading = 0; // Value to be displayed
long xss;
long yss;
int page;
int tankmpg;
int d = 0; // Variable used for the sinewave test waveform
int rd=0;
boolean alert = 0;
int8_t ramp = 1;











//void enableLButton(){PCMSK2  |= (1 << PCINT19);}
//void enableMButton(){PCMSK2  |= (1 << PCINT20);}
//void enableRButton(){PCMSK2  |= (1 << PCINT21);}
//array of the event functions}

pFunc eventFuncs[] ={
  enableVSS};
#define eventFuncSize (sizeof(eventFuncs)/sizeof(pFunc)) 
//define the event IDs
#define enableVSSID 0
//#define enableLButtonID 1
//#define enableMButtonID 2
//#define enableRButtonID 3
//ms counters
unsigned int eventFuncCounts[eventFuncSize];

//schedule an event to occur ms milliseconds from now
void addEvent(unsigned char eventID, unsigned int ms){
  if(ms == 0) {
    eventFuncs[eventID]();
  }
  else {
    eventFuncCounts[eventID]=ms;
  }
}

/* this ISR gets called every 1.024 milliseconds, we will call that a 
 * millisecond for our purposes go through all the event counts, if any 
 * are non zero subtract 1 and call the associated function if it just 
 * turned zero.  */
ISR(TIMER2_OVF_vect) {
  unsigned char eventID;
  timer2_overflow_count++;
  for(eventID = 0; eventID < eventFuncSize; eventID++) {
    if(eventFuncCounts[eventID]!= 0) {
      eventFuncCounts[eventID]--;
      if(eventFuncCounts[eventID] == 0) {
        eventFuncs[eventID](); 
      }
    }  
  }
} /* ISR(TIMER2_OVF_vect) */

//unsigned char buttonState = buttonsUp;      

//overflow counter used by millis2()      
unsigned long lastMicroSeconds=millis2() * 1000;   
unsigned long microSeconds(void) {     
  unsigned long tmp_timer2_overflow_count;    
  unsigned long tmp;    
  unsigned char tmp_tcnt2;    
  cli(); //disable interrupts    
  tmp_timer2_overflow_count = timer2_overflow_count;    
  tmp_tcnt2 = TCNT2;    
  sei(); // enable interrupts    
  tmp = ((tmp_timer2_overflow_count << 8) + tmp_tcnt2) * 4;     
  if((tmp<=lastMicroSeconds) && (lastMicroSeconds<4290560000ul)) {
    return microSeconds();     
  }
  lastMicroSeconds=tmp;   
  return tmp;     
}    

unsigned long elapsedMicroseconds(unsigned long startMicroSeconds, unsigned long currentMicroseconds) {      
  if(currentMicroseconds >= startMicroSeconds) {
    return currentMicroseconds-startMicroSeconds;      
  }
  return 0xFFFFFFFF - (startMicroSeconds-currentMicroseconds);      
}      

unsigned long elapsedMicroseconds(unsigned long startMicroSeconds ){      
  return elapsedMicroseconds(startMicroSeconds, microSeconds());
}      


//main objects we will be working with:      
unsigned long injHiStart; //for timing injector pulses      
Trip tmpTrip;      
Trip instant;      
Trip current;      
Trip tank;



unsigned volatile long instInjStart=nil; 
unsigned volatile long tmpInstInjStart=nil; 
unsigned volatile long instInjEnd; 
unsigned volatile long tmpInstInjEnd; 
unsigned volatile long instInjTot; 
unsigned volatile long tmpInstInjTot;     
unsigned volatile long instInjCount; 
unsigned volatile long tmpInstInjCount;     

boolean lookForOpenPulse = true;

void processInjOpen(void){      
  //20110831 AJT Peak and Hold ;)
  if(lookForOpenPulse || parms[injEdgeIdx] != 2){
    injHiStart = microSeconds();
  }
}      

void processInjClosed(void){
  //20110831 AJT Peak and Hold ;)
  long t =  microSeconds();
  long x = elapsedMicroseconds(injHiStart, t) - parms[injectorSettleTimeIdx];   

  if( parms[injEdgeIdx]==3 ){
    if (x >0) {
      tmpTrip.injHius += x;
    }
    tmpTrip.injPulses++;      
    if (tmpInstInjStart != nil) {
      if (x >0) {
        tmpInstInjTot += x;
      }
      tmpInstInjCount++;
    } 
    else {
      tmpInstInjStart = t;
    }
    tmpInstInjEnd = t;
  }
  else {
    if(parms[injEdgeIdx]==2 && x < 0){
      lookForOpenPulse=false;
    } 
    else {
      if(parms[injEdgeIdx]==2 || x > 0){
        tmpTrip.injHius += x;
      }

      tmpTrip.injPulses++;  
      if (tmpInstInjStart != nil) {
        if(parms[injEdgeIdx]==2 || x > 0){
          tmpInstInjTot += x;     
        }
        tmpInstInjCount++;
      } 
      else {
        tmpInstInjStart = t;
      }  
      tmpInstInjEnd = t;
      lookForOpenPulse=true;
    }
  }
}

volatile boolean vssFlop = 0;

void enableVSS(){
  vssFlop = !vssFlop;
}

unsigned volatile long lastVSS1;
unsigned volatile long lastVSSTime;
unsigned volatile long lastVSS2;

volatile boolean lastVssFlop = vssFlop;

//attach the vss/buttons interrupt      
ISR(PCINT2_vect) {   
  static unsigned char vsspinstate=0;      
  unsigned char p = PINK;//bypassing digitalRead for interrupt performance      

  if ((p & vssBit) != (vsspinstate & vssBit)){      
    addEvent(enableVSSID,parms[vsspause] ); //check back in a couple milli
  }
  if(lastVssFlop != vssFlop){


    lastVSS1=lastVSS2;
    unsigned long t = microSeconds();
    lastVSS2=elapsedMicroseconds(lastVSSTime,t);
    lastVSSTime=t;
    tmpTrip.vssPulses++; 
    tmpTrip.vssPulseLength += lastVSS2;
    lastVssFlop = vssFlop;
  }
  vsspinstate = p;      
  // buttonState &= p;      
} /* ISR(PCINT1_vect) */


pFunc displayFuncs[] ={ 
  doDisplay1, 
  doDisplay2, 
  doDisplay3, 
  doDisplay4, 
  doDisplay5, 


  doDisplayMenu,
  // doDisplayCarSensors,
};      

#define displayFuncSize (sizeof(displayFuncs)/sizeof(pFunc)) //array size      




//const OLED_Color GGREEN = { 11, 60, 3 };


unsigned char newRun = 0;

//const int pin=26;
const int pwmpin=12;

void setup (void) {
  //. delay(1000);
  myTouch.InitTouch(1);
  myTouch.setPrecision(PREC_LOW);
  //pinMode(pin, OUTPUT);
  //digitalWrite(pin,LOW);
  analogWrite(pwmpin,250);


  tft.begin();
  tft.setRotation(1);
  tft.fillScreen(TFT_BLACK);
  tft.setTextWrap(false);

  //. tft.drawString("MPGuino TFT Touch",             5,20, 4);
  //. tft.drawString("version 5.1 ",             5,50, 4);
  //.  tft.drawString("Continue...",             155,190, 4);
  //.  tft.drawString("Press and Hold here to",             155,180, 1);
  //.  tft.drawString("abbalooga 10.09.2018",       190,225, 1);
  //Serial.begin(9600);

  cp=0;





  //.  tft.fillScreen(TFT_BLACK);
  //. delay(2000);

  extrainfo=0;
  CLOCK = 0;
  SCREEN = 0;
  HOLD_DISPLAY = 0;

#if (CFG_IDLE_MESSAGE != 0)
  IDLE_DISPLAY_DELAY = 0;
#endif

  //edit september///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  //remove init at start
  init2();
  //debug
  // newRun = load();
  load();








  pinMode(InjectorOpenPin, INPUT);       
  pinMode(InjectorClosedPin, INPUT);       
  pinMode(VSSPin, INPUT);            
  attachInterrupt(0, processInjOpen, parms[injEdgeIdx]==1? RISING:FALLING);      
  attachInterrupt(1, processInjClosed, parms[injEdgeIdx]==1? FALLING:RISING); 

  //  pinMode( lbuttonPin, INPUT );       
  //  pinMode( mbuttonPin, INPUT );       
  //  pinMode( rbuttonPin, INPUT );      

  //"turn on" the internal pullup resistors      
  //   digitalWrite( lbuttonPin, HIGH);       
  //  digitalWrite( mbuttonPin, HIGH);       
  //  digitalWrite( rbuttonPin, HIGH);       
  digitalWrite( VSSPin, HIGH);       

  //low level interrupt enable stuff    
  //////////////////////////////////////////////////////////////////////////////////////////////////////////  
  // PCMSK1 |= (1 << PCINT8);


  //  enableLButton();
  //   enableMButton();
  //   enableRButton();
  // PCICR |= (1 << PCIE1);       






  PCMSK2 |= (1 << PCINT16); // enable VSS pin interrupt


  PCICR |= (1 << PCIE2); // enable selected interrupts on port K



  ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  //PRR0 |= ((1 << PRTWI) | (1 << PRSPI) | (1 << PRADC) | (1 << PRUSART0)); // disable TWI, SPI, ADC, USART0 modules to reduce power consumption
  //	PRR1 |= ((1 << PRTIM5) | (1 << PRTIM4) | (1 << PRTIM3) | (1 << PRUSART3) | (1 << PRUSART2) | (1 << PRUSART1)); // disable timer5, timer4, timer3, USART3, USART2, USART1 modules to reduce power consumption






  //  initGuino();


  //  delay(100);

} /* void setup (void) */


void loop (void) {
  long xss, yss;
  touchorient=parms[currentTripResetTimeoutUSIdx];

  //saveTankData();
  unsigned long fluff=1;
  unsigned long fluff2=1;
  unsigned long time=0;
  unsigned long lastActivity;
  unsigned long tankHold;      //state at point of last activity
  unsigned long loopStart;
  unsigned long temp;          //scratch variable
  unsigned poopp;
  lastActivity = microSeconds();

  loadTankData();
  while (true) {     

    loopStart = microSeconds();   

    unsigned poop=(microSeconds()-poopp);



#if (CFG_FUELCUT_INDICATOR != 0)
    FCUT_POS = 0;
#endif

#if (OUTSIDE_TEMP_CFG == 1)
    CALC_FILTERED_TEMP();
#endif
    touchorient=parms[currentTripResetTimeoutUSIdx];

    instant.reset();           //clear instant      
    cli();
    instant.update(tmpTrip);   //"copy" of tmpTrip in instant now      
    tmpTrip.reset();           //reset tmpTrip first so we don't lose too many interrupts      
    instInjStart=tmpInstInjStart; 
    instInjEnd=tmpInstInjEnd; 
    instInjTot=tmpInstInjTot;     
    instInjCount=tmpInstInjCount;

    tmpInstInjStart=nil; 
    tmpInstInjEnd=nil; 
    tmpInstInjTot=0;     
    tmpInstInjCount=0;

    sei();


    /* --- update all of the trip objects */
    current.update(instant);       //use instant to update current      
    tank.update(instant);          //use instant to update tank

      //  tft.drawNumber(fluff, 280,15, 1);
      // tft.drawNumber(fluff2, 280,23, 1);

    if (time>=1) time=time+1;
    if (time>=7) {
      tft.fillRect(   280,10,40,13,TFT_BLACK);
      time=0;
    }

    if ((fluff == 0)&&(instant.vssPulses==0)) {  //save tank data when stopped incase of car off before screen timeout
      saveTankData();
      fluff = 1;
      time=1;
      tft.drawString("SAVED", 280,15, 1);
    }  

    if ((instantrpm()>=1)&&(instant.vssPulses==0)){
      fluff=fluff+1;
      if (fluff>=40) { 
        saveTankData();
        fluff = 1;
        time=1;
        tft.drawString("SAVED", 280,15, 1);
      }
    }

    if (instantrpm()>=1){
      fluff2=fluff2+1;
      if (fluff2>=600) { 
        saveTankData();
        fluff2 = 1;
        time=1;
        tft.drawString("SAVED", 280,15, 1);
      }
    }

    if (instant.vssPulses>=1) fluff=0  ; //allow tank to be saved next time stopped

    // }






    if (HOLD_DISPLAY == 0) {

#if (CFG_IDLE_MESSAGE == 0)
      displayFuncs[SCREEN]();    //call the appropriate display routine      
#elif (CFG_IDLE_MESSAGE == 1)
      /* --- during idle, jump to EOC information */
      if (    (instant.injPulses >  0) 
        && (instant.vssPulses == 0) 
        ) 
      {
        /* the intention of the below logic is to avoid the display flipping 
         in stop and go traffic.  When you come to a stop, the delay timer 
         starts incrementing.  When you drive off, it decrements.  When the
         timer is zero, the display is always at the user-specified screen */
        if (IDLE_DISPLAY_DELAY < 6) {
          /* count up until delay time is reached */
          IDLE_DISPLAY_DELAY++;
        }
      }
      else {
        if (IdleDisplayRequested) {
          /* count from delay time back down to zero */
          IDLE_DISPLAY_DELAY--;
        }
        else if (IDLE_DISPLAY_DELAY < 0) {
          /* if the user selected a new screen while stopped, reset 
           the delay timer after driveoff */
          IDLE_DISPLAY_DELAY = 0;
        }
      }

      if (IdleDisplayRequested) {
        doDisplayEOCIdleData();
      }
      else {
        displayFuncs[SCREEN]();
      }
#endif



      if (SCREEN==5)   {
        SCREEN_2();
      }
      else
      {
        tft.setCursor(0, 0);

        myTouch.read();
        xss = myTouch.getX();
        yss = myTouch.getY();
        if (touchorient==1){ 
          xss=320-xss;
          yss=240-yss;
        }

        if (xss>=0 && xss<=100){
          if (yss>=150){
            cp=cp+1;
            if (cp>=3) {
              if (SCREEN!=0) {
                tft.fillScreen(TFT_BLACK);
                SCREEN--;       
              }
              else {
                tft.fillScreen(TFT_BLACK);
                SCREEN=4;      
              }
              cp=0;
            }
          }
          else if (yss>=1 && yss<=60){
            cp=cp+1;
            if (cp>=6) { 
              tft.fillScreen(TFT_BLACK);  
              cp=0; 
              tempscreen=SCREEN;
              SCREEN=5;  
              ;
            }
          }
        }

        if (xss>=230 && xss<=318){
          if(yss>=0 && yss<=100){
            cp=cp+1;
            if(cp>=3){
              screenstate=screenstate-40;
              if(screenstate<=25)screenstate=25; 
              analogWrite(pwmpin,screenstate);
            };
          };
          if(yss>= 150){
            cp=cp+1;
            if(cp>=3){
              screenstate=screenstate+40;
              if(screenstate>=254)screenstate=253;

              analogWrite(pwmpin,screenstate);
            };
          };
        }
        if (xss==-1) cp=0; 
        if (xss==321) cp=0; 
        if (yss==-1) cp=0; 
        if (yss==241) cp=0; 
        //if(screenstate>=254)screenstate=253;
        //if(screenstate<=5)screenstate=5;
        //if (lastActivity = nil){} else 
        //analogWrite(pwmpin,screenstate);
        //DEBUG TOUCH
        tft.setTextPadding(30);

        if (cp>=1) {
          lastActivity=loopStart;
          tft.setTextPadding(00);
          tft.drawNumber(cp,120,235,4);
        }
        else 
          tft.drawString("      ",120,235,4);


        if (cp>=2) analogWrite(pwmpin,screenstate);
        if (cp>=100)   {      
          tft.drawString("do you have nothing better to do...",5,235,1); 

        }

        tft.setTextPadding(00);

        if(parms[contrastIdx]==69){
          tft.drawString(format(xss*1000),190,235,1);
          tft.drawString(format(yss*1000),230,235,1);
          tft.drawString(format(elapsedMicroseconds(loopStart)),150,235,1);
        }
      }

    }  /* if (HOLD_DISPLAY == 0) */
    else {
      HOLD_DISPLAY = 0;
    } 

    MAXLOOPLENGTH = MAX(MAXLOOPLENGTH, elapsedMicroseconds(loopStart));

    while (elapsedMicroseconds(loopStart) < (looptime)) {
      // wait for the end of the loop to arrive (0.5 sec)
      continue;
    }

    CLOCK++;

  } /* while (true) */
} /* loop (void) */

//--------------------------------------------------------
char *format(unsigned long num) {
  static char fBuff[7];  //used by format
  unsigned char dp = 3;
  unsigned char x = 6;

  while (num > 999999) {
    num /= 10;
    dp++;
    if( dp == 5 ) break; /* We'll lose the top numbers like an odometer */
  }
  if (dp == 5) {
    dp = 99;
  }                       /* We don't need a decimal point here. */

  /* Round off the non-printed value. */
  if((num % 10) > 4) {
    num += 10;
  }

  num /= 10;


  while (x > 0) {
    x--;
    if (x == dp) {
      /* time to poke in the decimal point? */
      fBuff[x]='.';
    }
    else {
      /* poke the ascii character for the digit. */
      fBuff[x]= '0' + (num % 10);
      num /= 10;
    }
  }

  if( fBuff[0]=='0' ) { //if leftmost char is 0 then replace it with space: '099.56' => ' 99.56'
    fBuff[0]=' ';
    if( fBuff[1]=='0' ) fBuff[1]=' ';
  }

  fBuff[6] = 0;
  return fBuff;
}

//--------------------------------------------------------
char* intformat(unsigned long num, byte numlength=6)
{
  static char fBuff[7];  //used by format

  //if number doesn't fit, show 9999 (92 bytes)
  if(numlength==6 && num > 999999999){
    num = 999999000ul;
  }
  else if(numlength==5 && num > 99999999){
    num = 99999000ul;
  }
  else if(numlength==4 && num > 9999999){
    num = 9999000ul;
  }


  num /= 100;
  // Round off the non-printed value.
  if((num % 10) > 4) num += 10;
  num /= 10;

  byte x = numlength;
  fBuff[x] = 0;//end string with \0
  while(x > 0){
    x--;
    fBuff[x]= '0' + (num % 10);//poke the ascii character for the digit.
    num /= 10; 
  }

  //replace leading 0 with ' '
  boolean leadnulls = true;
  while(x < numlength-1 && leadnulls){
    fBuff[x]=='0' ? fBuff[x]=' ' : leadnulls = false;
    x++;
  }

  return fBuff;  
}

//get a string from flash 
char *getStr(prog_char * str) { 
  static char mBuff[17]; //used by getStr 
  strcpy_P(mBuff, str); 
  return mBuff; 
} 























int ringMeter(int value, int vmin, int vmax, int x, int y, int r, char *units, byte scheme, long tomato)
{
  // Minimum value of r is about 52 before value text intrudes on ring
  // drawing the text first is an option

  x += r; 
  y += r;   // Calculate coords of centre of ring

  int w = r / 3;    // Width of outer ring is 1/4 of radius

  int angle = 150;  // Half the sweep angle of meter (300 degrees)

  int v = map(value, vmin, vmax, -angle, angle); // Map the value to an angle v

  byte seg = 3; // Segments are 3 degrees wide = 100 segments for 300 degrees
  byte inc = 6; // Draw segments every 3 degrees, increase to 6 for segmented ring

  // Variable to save "value" text colour from scheme and set default
  int colour = TFT_BLUE;

  // Draw colour blocks every inc degrees
  for (int i = -angle+inc/2; i < angle-inc/2; i += inc) {
    // Calculate pair of coordinates for segment start
    float sx = cos((i - 90) * 0.0174532925);
    float sy = sin((i - 90) * 0.0174532925);
    uint16_t x0 = sx * (r - w) + x;
    uint16_t y0 = sy * (r - w) + y;
    uint16_t x1 = sx * r + x;
    uint16_t y1 = sy * r + y;

    // Calculate pair of coordinates for segment end
    float sx2 = cos((i + seg - 90) * 0.0174532925);
    float sy2 = sin((i + seg - 90) * 0.0174532925);
    int x2 = sx2 * (r - w) + x;
    int y2 = sy2 * (r - w) + y;
    int x3 = sx2 * r + x;
    int y3 = sy2 * r + y;

    if (i < v) { // Fill in coloured segments with 2 triangles
      switch (scheme) {
      case 0: 
        colour = TFT_RED; 
        break; // Fixed colour
      case 1: 
        colour = TFT_GREEN; 
        break; // Fixed colour
      case 2: 
        colour = TFT_BLUE; 
        break; // Fixed colour
      case 3: 
        colour = rainbow(map(i, -angle, angle, 0, 127)); 
        break; // Full spectrum blue to red
      case 4: 
        colour = rainbow(map(i, -angle, angle, 70, 127)); 
        break; // Green to red (high temperature etc)
      case 5: 
        colour = rainbow(map(i, -angle, angle, 127, 63)); 
        break; // Red to green (low battery etc)
      default: 
        colour = TFT_BLUE; 
        break; // Fixed colour
      }
      tft.fillTriangle(x0, y0, x1, y1, x2, y2, colour);
      tft.fillTriangle(x1, y1, x2, y2, x3, y3, colour);
      //text_colour = colour; // Save the last colour drawn
    }
    else // Fill in blank segments
    {
      tft.fillTriangle(x0, y0, x1, y1, x2, y2, HX8357_GREY);
      tft.fillTriangle(x1, y1, x2, y2, x3, y3, HX8357_GREY);
    }
  }
  // Convert value to a string
  char buf[10];
  byte len = 3; 
  if (value > 999) len = 5;
  dtostrf((value/10), len, 0, buf);
  buf[len] = ' '; 
  buf[len+1] = 0; // Add blanking space and terminator, helps to centre text too!
  // Set the text colour to default
  tft.setTextSize(1);

  if (value<vmin || value>vmax) {
    drawAlert(x,y+60,50,1);
  }
  else {
    drawAlert(x,y+60,50,0);
  }

  tft.setTextColor(TFT_WHITE, TFT_BLACK);
  // Uncomment next line to set the text colour to the last segment value!
  tft.setTextColor(colour, TFT_BLACK);
  tft.setTextDatum(MC_DATUM);
  // Print value, if the meter is large then use big font 8, othewise use 4
  tft.setTextPadding(130);

  tft.drawString(format(tomato), x-5, y, 4); // Value in middle





  tft.setTextSize(1);
  tft.setTextPadding(0);
  // Print units, if the meter is large then use big font 4, othewise use 2






  // Calculate and return right hand side x coordinate
  return x + r;
}


void drawAlert(int x, int y , int side, boolean draw)
{
  if (draw && !alert) {
    tft.fillTriangle(x, y, x+30, y+47, x-30, y+47, rainbow(95));
    tft.setTextColor(TFT_BLACK);
    tft.drawCentreString("!", x, y + 17, 4);
    alert = 1;
  }
  else if (!draw) {
    tft.fillTriangle(x, y, x+30, y+47, x-30, y+47, TFT_BLACK);
    alert = 0;
  }
}

// #########################################################################
// Return a 16 bit rainbow colour
// #########################################################################
unsigned int rainbow(byte value)
{
  // Value is expected to be in range 0-127
  // The value is converted to a spectrum colour from 0 = blue through to 127 = red

  byte red = 0; // Red is the top 5 bits of a 16 bit colour value
  byte green = 0;// Green is the middle 6 bits
  byte blue = 0; // Blue is the bottom 5 bits

  byte quadrant = value / 32;

  if (quadrant == 0) {
    blue = 31;
    green = 2 * (value % 32);
    red = 0;
  }
  if (quadrant == 1) {
    blue = 31 - (value % 32);
    green = 63;
    red = 0;
  }
  if (quadrant == 2) {
    blue = 0;
    green = 63;
    red = value % 32;
  }
  if (quadrant == 3) {
    blue = 0;
    green = 63 - 2 * (value % 32);
    red = 31;
  }
  return (red << 11) + (green << 5) + blue;
}







unsigned long getDTE(void){
  unsigned long dte;
  signed long fuel_remaining;
  fuel_remaining = parms[tankSizeIdx] - tank.gallons()+fueladd;
  fuel_remaining = MAX(fuel_remaining, 0);

  /*
   init64(tmp1,0,fuel_remaining);
   init64(tmp2,0,100000ul);
   mul64(tmp1,tmp2);
   
   dte = tank.mpg();
   init64(tmp2,0,dte);
   div64(tmp1,tmp2); //something here does not work...
   
   return tmp1[1];
   */


  //dte = (fuel_remaining * 100000) / tank.mpg(); //dont work, multiplied number gets too big
  dte = ((fuel_remaining * 1000) / current.mpg()) * 100;
  // dte = ((fuel_remaining * 1000) / ((14345))) *100;


  return dte;
} 









//Trip::Trip(){      
//}      


unsigned long instantmph(){  
  //unsigned long vssPulseTimeuS = (lastVSS1 + lastVSS2) / 2;
  unsigned long vssPulseTimeuS = instant.vssPulseLength/instant.vssPulses;

  init64(tmp1,0,1000000000ul);
  init64(tmp2,0,parms[vssPulsesPerMileIdx]);
  div64(tmp1,tmp2);
  init64(tmp2,0,3600);
  mul64(tmp1,tmp2);
  init64(tmp2,0,vssPulseTimeuS);
  div64(tmp1,tmp2);

  return tmp1[1];
}

unsigned long instantmpg(){     
  unsigned long imph=instantmph();
  unsigned long igph=instantgph();

#if(CFG_UNITS==2) // km
  if(imph == 0) return 999999000;
  if(igph == 0) return 0;
#else // miles
  if(imph == 0) return 0;
  if(igph == 0) return 999999000;  
#endif

  init64(tmp1,0,1000ul);
  init64(tmp2,0,imph);
  mul64(tmp1,tmp2);
  init64(tmp2,0,igph);
  div64(tmp1,tmp2);

#if(CFG_UNITS==2) // km
  //convert km/L to L/100km
  init64(tmp2,0,100000000ul);
  div64(tmp2,tmp1);
  return tmp2[1];
#else 
  return tmp1[1];
#endif 
}

unsigned long instantgph(){      
  //  unsigned long vssPulseTimeuS = instant.vssPulseLength/instant.vssPulses;

  //  unsigned long instInjStart=nil; 
  //unsigned long instInjEnd; 
  //unsigned long instInjTot; 
  init64(tmp1,0,instInjTot);
  init64(tmp2,0,3600000000ul);
  mul64(tmp1,tmp2);
  init64(tmp2,0,1000ul);
  mul64(tmp1,tmp2);
  init64(tmp2,0,parms[microSecondsPerGallonIdx]);
  div64(tmp1,tmp2);
  init64(tmp2,0,instInjEnd-instInjStart);
  div64(tmp1,tmp2);
  return tmp1[1];      
}

unsigned long instantrpm(){      
  init64(tmp1,0,instInjCount);
  init64(tmp2,0,120000000ul);
  mul64(tmp1,tmp2);
  init64(tmp2,0,1000ul);
  mul64(tmp1,tmp2);
  init64(tmp2,0,parms[injPulsesPer2Revolutions]);
  div64(tmp1,tmp2);
  init64(tmp2,0,instInjEnd-instInjStart);
  div64(tmp1,tmp2);

  return (tmp1[1] / 10000)*10000; //make last digit to be 0
  //return tmp1[1];
} 

unsigned long Trip::miles(){      
  init64(tmp1,0,vssPulses);
  init64(tmp2,0,1000);
  mul64(tmp1,tmp2);
  init64(tmp2,0,parms[vssPulsesPerMileIdx]);
  div64(tmp1,tmp2);
  return tmp1[1];      
}      

unsigned long Trip::eocMiles(){      
  init64(tmp1,0,vssEOCPulses);
  init64(tmp2,0,1000);
  mul64(tmp1,tmp2);
  init64(tmp2,0,parms[vssPulsesPerMileIdx]);
  div64(tmp1,tmp2);
  return tmp1[1];      
}       

unsigned long Trip::mph(){      
  if(loopCount == 0)     
    return 0;     
  init64(tmp1,0,loopsPerSecond);
  init64(tmp2,0,vssPulses);
  mul64(tmp1,tmp2);
  init64(tmp2,0,3600000);
  mul64(tmp1,tmp2);
  init64(tmp2,0,parms[vssPulsesPerMileIdx]);
  div64(tmp1,tmp2);
  init64(tmp2,0,loopCount);
  div64(tmp1,tmp2);
  return tmp1[1];      
}      

unsigned long  Trip::gallons(){      
  init64(tmp1,0,injHiSec);
  init64(tmp2,0,1000000);
  mul64(tmp1,tmp2);
  init64(tmp2,0,injHius);
  add64(tmp1,tmp2);
  init64(tmp2,0,1000);
  mul64(tmp1,tmp2);
  init64(tmp2,0,parms[microSecondsPerGallonIdx]);
  div64(tmp1,tmp2);
  return tmp1[1];      
}      

unsigned long  Trip::idleGallons(){      
  init64(tmp1,0,injIdleHiSec);
  init64(tmp2,0,1000000);
  mul64(tmp1,tmp2);
  init64(tmp2,0,injIdleHius);
  add64(tmp1,tmp2);
  init64(tmp2,0,1000);
  mul64(tmp1,tmp2);
  init64(tmp2,0,parms[microSecondsPerGallonIdx]);
  div64(tmp1,tmp2);
  return tmp1[1];      
}      

//eocMiles
//idleGallons

unsigned long  Trip::mpg(){
#if(CFG_UNITS==2) // km
  if(vssPulses==0) return 999999000;      
  if(injPulses==0) return 0;
#else // miles
  if(vssPulses==0) return 0;      
  if(injPulses==0) return 999999000; //who doesn't like to see 999999?  :)    
#endif

  init64(tmp1,0,injHiSec);
  init64(tmp3,0,1000000);
  mul64(tmp3,tmp1);
  init64(tmp1,0,injHius);
  add64(tmp3,tmp1);
  init64(tmp1,0,parms[vssPulsesPerMileIdx]);
  mul64(tmp3,tmp1);

  init64(tmp1,0,parms[microSecondsPerGallonIdx]);
  init64(tmp2,0,1000);
  mul64(tmp1,tmp2);
  init64(tmp2,0,vssPulses);
  mul64(tmp1,tmp2);

  div64(tmp1,tmp3);

#if(CFG_UNITS==2) // km
  //convert km/L to L/100km
  init64(tmp2,0,100000000ul);
  div64(tmp2,tmp1);
  return tmp2[1];
#else 
  return tmp1[1];
#endif 
}      

//return the hhh:mm      
unsigned long Trip::time(){          
  unsigned long seconds = (loopCount/loopsPerSecond)/60; //minutes actually         
  return ((seconds/60)*1000) + ((seconds%60) * 10);       
}



void Trip::reset(){      
  loopCount = 0;      
  injPulses = 0;      
  injHius = 0;      
  injHiSec = 0;      
  vssPulses = 0;  
  vssPulseLength = 0;
  injIdleHiSec = 0;
  injIdleHius = 0;
  vssEOCPulses = 0;

}      

void Trip::update(Trip t) {
  if(t.vssPulses || t.injPulses) { 
    loopCount++;  //we call update once per loop
  }
  vssPulses += t.vssPulses;      
  vssPulseLength += t.vssPulseLength;
  if ( t.injPulses == 0 )  //track distance traveled with engine off
    vssEOCPulses += t.vssPulses;

  if ( t.injPulses > 2 && t.injHius < 500000 ) {// chasing ghosts      
    injPulses += t.injPulses;      
    injHius += t.injHius;      
    if (injHius >= 1000000){  
      // rollover into the injHiSec counter      
      injHiSec++;      
      injHius -= 1000000;      
    }
    if(t.vssPulses == 0) {    
      // track gallons spent sitting still
      injIdleHius += t.injHius;      
      if (injIdleHius >= 1000000) {  //r
        injIdleHiSec++;
        injIdleHius -= 1000000;      
      }      
    }
  }      
}   




int insert(int *array, int val, size_t size, size_t at)
{
  size_t i;

  /* In range? */
  if (at >= size)
    return -1;

  /* Shift elements to make a hole */
  for (i = size - 1; i > at; i--)
    array[i] = array[i - 1];
  /* Insertion! */
  array[at] = val;

  return 0;
}

void save(){
  EEPROM.write(0,guinosig);
  EEPROM.write(1,mylength(parms));
  writeEepBlock32(0x04, &parms[0], mylength(parms));
}

void writeEepBlock32(unsigned int start_addr, unsigned long *val, unsigned int size) {
  unsigned char p = 0;
  unsigned char shift = 0;
  int i = 0;
  for(start_addr; p < size; start_addr+=4) {
    for (i=0; i<4; i++) {
      shift = (8 * (3-i));  /* 24, 16, 8, 0 */
      EEPROM.write(start_addr + i, (val[p]>>shift) & 0xFF);
    }
    p++;
  }
}

void readEepBlock32(unsigned int start_addr, unsigned long *val, unsigned int size) {
  unsigned long v = 0;
  unsigned char p = 0;
  unsigned char temp = 0;
  unsigned char i = 0;
  for(start_addr; p < size; start_addr+=4) {
    v = 0;   /* clear the scratch variable every loop! */
    for (i=0; i<4; i++) {
      temp = (i > 0) ? 1 : 0;  /* 0, 1, 1, 1  */
      v = (v << (temp * 8)) + EEPROM.read(start_addr + i);
    }
    val[p] = v;
    p++;
  }
}

//#if (TANK_IN_EEPROM_CFG == 1)
void saveTankData() {
  unsigned long var[] = {
    //current.loopCount,
    current.injPulses,
    current.injHiSec,
    current.injHius,
    //   tank.injIdleHiSec,
    //   tank.injIdleHius,
    current.vssPulses,
    //  tank.vssPulseLength,
    tank.loopCount,
    tank.injPulses,
    tank.injHiSec,
    tank.injHius,
    //  current.injIdleHiSec,
    //  current.injIdleHius,
    tank.vssPulses
      //  current.vssPulseLength
  };
  writeEepBlock32(eepBlkAddr_Tank, &var[0], eepBlkSize_Tank);
}

void loadTankData() {
  unsigned long var[9];
  readEepBlock32(eepBlkAddr_Tank, &var[0], eepBlkSize_Tank);
  //current.loopCount = var[0];
  current.injPulses = var[0];
  current.injHiSec = var[1];
  current.injHius = var[2];
  // tank.injIdleHiSec = var[4];
  // tank.injIdleHius = var[5];
  current.vssPulses = var[3];
  // tank.vssPulseLength = var[5];
  tank.loopCount = var[4];
  tank.injPulses = var[5];
  tank.injHiSec = var[6];
  tank.injHius = var[7];
  // current.injIdleHiSec = var[12];
  // current.injIdleHius = var[13];
  tank.vssPulses = var[8];
  // current.vssPulseLength = var[11];
}
//#endif

unsigned char load(){ //return 1 if loaded ok
#ifdef usedefaults
  return 1;
#endif
  unsigned char b = EEPROM.read(0);
  unsigned char c = EEPROM.read(1);
  if(b == guinosigold)
    c=9; //before fancy parameter counter

  if(b == guinosig || b == guinosigold){
    readEepBlock32(0x04, &parms[0], mylength(parms));
    //#if (TANK_IN_EEPROM_CFG == 1)
    /* read out the tank variables on boot */
    /* TODO:  eepBlkSize_Tank is appropriate for size? */
    // readEepBlock32(eepBlkAddr_Tank, &tank.var[0], eepBlkSize_Tank);
    loadTankData();
    //#endif
    return 1;
  }
  return 0;
}

char * uformat(unsigned long val){ 
  static char mBuff[17];
  unsigned long d = 1000000000ul;
  unsigned char p;
  for(p = 0; p < 10 ; p++){
    mBuff[p]='0' + (val/d);
    val=val-(val/d*d);
    d/=10;
  }
  mBuff[10]=0;
  return mBuff;
} 

unsigned long rformat(char * val){ 
  unsigned long d = 1000000000ul;
  unsigned long v = 0ul;
  for(unsigned char p = 0; p < 10 ; p++){
    v=v+(d*(val[p]-'0'));
    d/=10;
  }
  return v;
} 


boolean editParm(unsigned char parmIdx){
  unsigned long v = parms[parmIdx];
  unsigned char p=9;  //right end of 10 digit number
  unsigned char keyLock=1;    
  long xss,yss;
  char *fmtv = uformat(v);
  tft.setTextDatum(TL_DATUM);

  /* -- line 1 -- */
  tft.drawString(parmLabels[parmIdx], 10, 30, 4);
  tft.drawString("OK   EXIT",166,70,4);


  tft.fillRect(   40,190,40,8,TFT_WHITE);
  tft.fillRect(   156,169,8,50,TFT_WHITE);
  tft.fillRect(   240,190,40,8,TFT_WHITE);

  tft.drawLine( 160,150,150,170,TFT_WHITE);
  tft.drawLine( 160,150,151,170,TFT_WHITE);
  tft.drawLine( 160,150,152,170,TFT_WHITE);
  tft.drawLine( 160,150,153,170,TFT_WHITE);
  tft.drawLine( 160,150,154,170,TFT_WHITE);
  tft.drawLine( 160,150,155,170,TFT_WHITE);
  tft.drawLine( 160,150,156,170,TFT_WHITE);
  tft.drawLine( 160,150,157,170,TFT_WHITE);
  tft.drawLine( 160,150,158,170,TFT_WHITE);
  tft.drawLine( 160,150,159,170,TFT_WHITE);
  tft.drawLine( 160,150,160,170,TFT_WHITE);
  tft.drawLine( 160,150,161,170,TFT_WHITE);
  tft.drawLine( 160,150,162,170,TFT_WHITE);
  tft.drawLine( 160,150,163,170,TFT_WHITE);
  tft.drawLine( 160,150,164,170,TFT_WHITE);
  tft.drawLine( 160,150,165,170,TFT_WHITE);
  tft.drawLine( 160,150,166,170,TFT_WHITE);
  tft.drawLine( 160,150,167,170,TFT_WHITE);
  tft.drawLine( 160,150,168,170,TFT_WHITE);
  tft.drawLine( 160,150,169,170,TFT_WHITE);
  tft.drawLine( 160,150,170,170,TFT_WHITE);


  tft.drawLine( 25,194,45,184,TFT_WHITE);
  tft.drawLine( 25,194,45,185,TFT_WHITE);
  tft.drawLine( 25,194,45,186,TFT_WHITE);
  tft.drawLine( 25,194,45,187,TFT_WHITE);
  tft.drawLine( 25,194,45,188,TFT_WHITE);
  tft.drawLine( 25,194,45,189,TFT_WHITE);
  tft.drawLine( 25,194,45,190,TFT_WHITE);
  tft.drawLine( 25,194,45,191,TFT_WHITE);
  tft.drawLine( 25,194,45,192,TFT_WHITE);
  tft.drawLine( 25,194,45,193,TFT_WHITE);
  tft.drawLine( 25,194,45,194,TFT_WHITE);
  tft.drawLine( 25,194,45,195,TFT_WHITE);
  tft.drawLine( 25,194,45,196,TFT_WHITE);
  tft.drawLine( 25,194,45,197,TFT_WHITE);
  tft.drawLine( 25,194,45,198,TFT_WHITE);
  tft.drawLine( 25,194,45,199,TFT_WHITE);
  tft.drawLine( 25,194,45,200,TFT_WHITE);
  tft.drawLine( 25,194,45,201,TFT_WHITE);
  tft.drawLine( 25,194,45,202,TFT_WHITE);
  tft.drawLine( 25,194,45,203,TFT_WHITE);
  tft.drawLine( 25,194,45,204,TFT_WHITE);

  tft.drawLine(275,184,295,194,TFT_WHITE);
  tft.drawLine(275,185,295,194,TFT_WHITE);
  tft.drawLine(275,186,295,194,TFT_WHITE);
  tft.drawLine(275,187,295,194,TFT_WHITE);
  tft.drawLine(275,188,295,194,TFT_WHITE);
  tft.drawLine(275,189,295,194,TFT_WHITE);
  tft.drawLine(275,190,295,194,TFT_WHITE);
  tft.drawLine(275,191,295,194,TFT_WHITE);
  tft.drawLine(275,192,295,194,TFT_WHITE);
  tft.drawLine(275,193,295,194,TFT_WHITE);
  tft.drawLine(275,194,295,194,TFT_WHITE);
  tft.drawLine(275,195,295,194,TFT_WHITE);
  tft.drawLine(275,196,295,194,TFT_WHITE);
  tft.drawLine(275,197,295,194,TFT_WHITE);
  tft.drawLine(275,198,295,194,TFT_WHITE);
  tft.drawLine(275,199,295,194,TFT_WHITE);
  tft.drawLine(275,200,295,194,TFT_WHITE);
  tft.drawLine(275,201,295,194,TFT_WHITE);
  tft.drawLine(275,202,295,194,TFT_WHITE);
  tft.drawLine(275,203,295,194,TFT_WHITE);
  tft.drawLine(275,204,295,194,TFT_WHITE);

  /* -- line 2 -- */
  tft.drawString(fmtv,10,70,4);

  /* -- turn the cursor on -- */
  //   LCD::LcdCommandWrite(LCD_DisplayOnOffCtrl | LCD_DisplayOnOffCtrl_DispOn | LCD_DisplayOnOffCtrl_CursOn);
  /* cursor on 'OK' by default except for contrast */
  (parmIdx == contrastIdx) ? p=8 : p=10;  

  while(true){


    tft.drawLine(9,91,330,91,TFT_BLACK);
    tft.drawLine(9,92,330,92,TFT_BLACK);
    if (p==10){
      tft.drawLine(165,91,205,91,TFT_BLUE); 
      tft.drawLine(165,92,205,92,TFT_BLUE); 
    }
    else
      if (p==11){
        tft.drawLine(216,91,270,91,TFT_BLUE); 
        tft.drawLine(216,92,270,92,TFT_BLUE); 
      }
    else{
      tft.drawLine(9+(14*(p)),91,9+(14*(p))+15,91,TFT_BLUE); 
      tft.drawLine(9+(14*(p)),92,9+(14*(p))+15,92,TFT_BLUE); 
    }

    tft.setCursor(0, 0);      

    myTouch.read();

    xss = myTouch.getX();
    yss = myTouch.getY();
    if (touchorient==0){ 
      xss=320-xss;
      yss=240-yss;
    }

    if (yss>=150){   
      if (xss>=0 && xss<=100){
        cp=cp+1;
        if (cp>=2) {
          p--;
          if(p==255)p=11;
          cp=0;
        }
      };
      if (xss>=110 && xss<=210){
        cp=cp+1;
        if (cp>=2) { 
          {
            ;
            cp=0;
            if(p==10){  //ok selected
              parms[parmIdx]=rformat(fmtv);
              //   LCD::LcdCommandWrite(B00001100); //cursor off
              tft.fillScreen(TFT_BLACK);

              SCREEN=tempscreen;
              delay2(250);
              return true;
            }
            else if(p==11){  //cancel selected
              //    LCD::LcdCommandWrite(B00001100); //cursor off
              tft.fillScreen(TFT_BLACK);
              SCREEN=tempscreen;
              delay2(250);
              return false;
            }   			 

            unsigned char n = fmtv[p]-'0';
            n++;
            if (n > 9) n=0;
            if(p==0 && n > 3) n=0;
            fmtv[p]='0'+ n;
            //   LCD::gotoXY(0,1);        
            //    LCD::print(fmtv);
            //   LCD::gotoXY(p,1);  
            tft.drawString(fmtv,10,70,4);
          }  
        }
      };
      if (xss>=220 && xss<=318){
        cp=cp+1;
        if (cp>=2) {
          p++;
          if(p==12)p=0;
          cp=0;
        }
      };
    }
    if (xss==-1) cp=0;  
    if (xss==321) cp=0;  
    delay2(35);
  }


}

boolean configFill(unsigned char parmIdx){
  unsigned long v = parms[parmIdx];
  long xss,yss,recty;
  //int rectyy;
  unsigned char p=5;  //right end of 10 digit number
  unsigned char keyLock=1;    

  char *fmtv = uformat(tank.gallons()-fueladd);
  tft.setTextDatum(TL_DATUM);

  /* -- line 1 -- */
  tft.drawString("Correct amount of fuel filled:", 10, 30, 4);
  tft.drawString("OK   EXIT",166,70,4);
  tft.setTextPadding(16);

  tft.drawString("L",10+(14*(9)),70,4);

  tft.fillRect(   40,190,40,8,TFT_WHITE);
  tft.fillRect(   156,169,8,50,TFT_WHITE);
  tft.fillRect(   240,190,40,8,TFT_WHITE);

  tft.drawLine( 160,150,150,170,TFT_WHITE);
  tft.drawLine( 160,150,151,170,TFT_WHITE);
  tft.drawLine( 160,150,152,170,TFT_WHITE);
  tft.drawLine( 160,150,153,170,TFT_WHITE);
  tft.drawLine( 160,150,154,170,TFT_WHITE);
  tft.drawLine( 160,150,155,170,TFT_WHITE);
  tft.drawLine( 160,150,156,170,TFT_WHITE);
  tft.drawLine( 160,150,157,170,TFT_WHITE);
  tft.drawLine( 160,150,158,170,TFT_WHITE);
  tft.drawLine( 160,150,159,170,TFT_WHITE);
  tft.drawLine( 160,150,160,170,TFT_WHITE);
  tft.drawLine( 160,150,161,170,TFT_WHITE);
  tft.drawLine( 160,150,162,170,TFT_WHITE);
  tft.drawLine( 160,150,163,170,TFT_WHITE);
  tft.drawLine( 160,150,164,170,TFT_WHITE);
  tft.drawLine( 160,150,165,170,TFT_WHITE);
  tft.drawLine( 160,150,166,170,TFT_WHITE);
  tft.drawLine( 160,150,167,170,TFT_WHITE);
  tft.drawLine( 160,150,168,170,TFT_WHITE);
  tft.drawLine( 160,150,169,170,TFT_WHITE);
  tft.drawLine( 160,150,170,170,TFT_WHITE);


  tft.drawLine( 25,194,45,184,TFT_WHITE);
  tft.drawLine( 25,194,45,185,TFT_WHITE);
  tft.drawLine( 25,194,45,186,TFT_WHITE);
  tft.drawLine( 25,194,45,187,TFT_WHITE);
  tft.drawLine( 25,194,45,188,TFT_WHITE);
  tft.drawLine( 25,194,45,189,TFT_WHITE);
  tft.drawLine( 25,194,45,190,TFT_WHITE);
  tft.drawLine( 25,194,45,191,TFT_WHITE);
  tft.drawLine( 25,194,45,192,TFT_WHITE);
  tft.drawLine( 25,194,45,193,TFT_WHITE);
  tft.drawLine( 25,194,45,194,TFT_WHITE);
  tft.drawLine( 25,194,45,195,TFT_WHITE);
  tft.drawLine( 25,194,45,196,TFT_WHITE);
  tft.drawLine( 25,194,45,197,TFT_WHITE);
  tft.drawLine( 25,194,45,198,TFT_WHITE);
  tft.drawLine( 25,194,45,199,TFT_WHITE);
  tft.drawLine( 25,194,45,200,TFT_WHITE);
  tft.drawLine( 25,194,45,201,TFT_WHITE);
  tft.drawLine( 25,194,45,202,TFT_WHITE);
  tft.drawLine( 25,194,45,203,TFT_WHITE);
  tft.drawLine( 25,194,45,204,TFT_WHITE);

  tft.drawLine(275,184,295,194,TFT_WHITE);
  tft.drawLine(275,185,295,194,TFT_WHITE);
  tft.drawLine(275,186,295,194,TFT_WHITE);
  tft.drawLine(275,187,295,194,TFT_WHITE);
  tft.drawLine(275,188,295,194,TFT_WHITE);
  tft.drawLine(275,189,295,194,TFT_WHITE);
  tft.drawLine(275,190,295,194,TFT_WHITE);
  tft.drawLine(275,191,295,194,TFT_WHITE);
  tft.drawLine(275,192,295,194,TFT_WHITE);
  tft.drawLine(275,193,295,194,TFT_WHITE);
  tft.drawLine(275,194,295,194,TFT_WHITE);
  tft.drawLine(275,195,295,194,TFT_WHITE);
  tft.drawLine(275,196,295,194,TFT_WHITE);
  tft.drawLine(275,197,295,194,TFT_WHITE);
  tft.drawLine(275,198,295,194,TFT_WHITE);
  tft.drawLine(275,199,295,194,TFT_WHITE);
  tft.drawLine(275,200,295,194,TFT_WHITE);
  tft.drawLine(275,201,295,194,TFT_WHITE);
  tft.drawLine(275,202,295,194,TFT_WHITE);
  tft.drawLine(275,203,295,194,TFT_WHITE);
  tft.drawLine(275,204,295,194,TFT_WHITE);
  /* -- line 2 -- */
  tft.drawString(fmtv,10,70,4);

  /* -- turn the cursor on -- */
  //   LCD::LcdCommandWrite(LCD_DisplayOnOffCtrl | LCD_DisplayOnOffCtrl_DispOn | LCD_DisplayOnOffCtrl_CursOn);
  /* cursor on 'OK' by default except for contrast */
  // (parmIdx == contrastIdx) ? p=8 : p=10;  

  while(true){

    tft.fillRect(9+(14*(7)),88,3,3,TFT_WHITE); 
    //  tft.fillRect(9+(14*(9)),70,15,21,TFT_BLACK); 
    tft.drawString("L",11+(14*(9)),70,4);

    tft.drawLine(9,91,330,91,TFT_BLACK);
    tft.drawLine(9,92,330,92,TFT_BLACK);
    if (p==10){
      tft.drawLine(165,91,205,91,TFT_BLUE); 
      tft.drawLine(165,92,205,92,TFT_BLUE); 
    }
    else
      if (p==11){
        tft.drawLine(216,91,270,91,TFT_BLUE); 
        tft.drawLine(216,92,270,92,TFT_BLUE); 
      }
    else{
      tft.drawLine(9+(14*(p)),91,9+(14*(p))+15,91,TFT_BLUE); 
      tft.drawLine(9+(14*(p)),92,9+(14*(p))+15,92,TFT_BLUE); 
    }


    tft.setCursor(0, 0);

    myTouch.read();
    xss = myTouch.getX();
    yss = myTouch.getY();
    if (touchorient==0){ 
      xss=320-xss;
      yss=240-yss;
    }

    if (yss>=150){   
      if (xss>=0 && xss<=100){
        cp=cp+1;
        if (cp>=2) {
          p--;
          if(p==255)p=11;
          if(p==9)p=8;
          cp=0;
        }
      };
      if (xss>=110 && xss<=210){
        cp=cp+1;
        if (cp>=2) { 
          {
            ;
            cp=0;
            if(p==10){  //ok selected
              // parms[parmIdx]=rformat(fmtv);
              //   LCD::LcdCommandWrite(B00001100); //cursor off
              tft.fillScreen(TFT_BLACK);
              recty=((parms[microSecondsPerGallonIdx]/1000)*tank.gallons())/(rformat(fmtv)+fueladd);
              parms[microSecondsPerGallonIdx] =recty*1000;
              SCREEN=tempscreen;
              delay2(250);
              return true;
            }
            else if(p==11){  //cancel selected
              //    LCD::LcdCommandWrite(B00001100); //cursor off
              tft.fillScreen(TFT_BLACK);
              SCREEN=tempscreen;
              delay2(250);
              return false;
            }   			 

            unsigned char n = fmtv[p]-'0';
            n++;
            if (n > 9) n=0;
            if(p==0 && n > 3) n=0;
            fmtv[p]='0'+ n;
            //   LCD::gotoXY(0,1);        
            //    LCD::print(fmtv);
            //   LCD::gotoXY(p,1);  
            tft.drawString(fmtv,10,70,4);
          }  
        }
      };
      if (xss>=220 && xss<=318){
        cp=cp+1;
        if (cp>=2) {
          p++;
          if(p==12)p=0;
          if(p==9)p=10;
          cp=0;
        }
      };
    }
    if (xss==-1) cp=0;  
    if (xss==321) cp=0;  







    delay2(35);
  }


}


boolean configFillcheck(unsigned char parmIdx){
  unsigned long v = parms[parmIdx];
  long xss,yss,recty;
  //int rectyy;
  unsigned char p=5;  //right end of 10 digit number
  unsigned char keyLock=1;    
  cp=0;
  char *fmtv = uformat(tank.gallons()-fueladd);
  tft.setTextDatum(TL_DATUM);

  tft.drawString("Did you just fill ", 10, 30, 4);
  tft.drawString(format(tank.gallons()-fueladd),110,60,6);
  tft.drawString("litres...", 230, 100, 4);


  tft.setTextPadding(16);


  while(true){
    tft.setTextColor(TFT_WHITE, TFT_BLACK);

    tft.drawString("YES", 30, 160, 4);
    tft.drawString("NO", 250, 160, 4);
    tft.drawString("CANCEL", 114, 190, 4);

    myTouch.read();
    xss = myTouch.getX();
    yss = myTouch.getY();
    if (touchorient==0){ 
      xss=320-xss;
      yss=240-yss;
    }

    if (yss>=150){   
      if (xss>=0 && xss<=80){
        cp=cp+1;
        tft.setTextColor(TFT_BLACK,TFT_WHITE);
        tft.drawString("YES", 30, 160, 4);
        tft.setTextColor(TFT_WHITE, TFT_BLACK);

        if (cp>=2) {
          /////////////////
          tft.fillScreen(TFT_BLACK); 
          tank.reset(); 
          tft.fillScreen(TFT_BLACK);

          tft.setTextColor(TFT_WHITE, TFT_BLACK);

          tft.drawString("TANK RESET",40,100,4);
          delay2(1000);
          return false;
        }
      };
      if (xss>=120 && xss<=200){
        tft.setTextColor(TFT_BLACK,TFT_WHITE);
        tft.drawString("CANCEL", 114, 190, 4);
        tft.setTextColor(TFT_WHITE, TFT_BLACK);
        cp=cp+1;
        if (cp>=2) { 
          tft.fillScreen(TFT_BLACK);  
          return false;
        }
      };
      if (xss>=240 && xss<=318){
        tft.setTextColor(TFT_BLACK,TFT_WHITE);
        tft.drawString("NO", 250, 160, 4);
        tft.setTextColor(TFT_WHITE, TFT_BLACK);
        cp=cp+1;
        if (cp>=2) { 
          tft.fillScreen(TFT_BLACK);  
          delay2(1000);
          configtank();
          return false;
        }
      };
    }
    if (xss==-1) cp=0;  
    if (xss==321) cp=0;  


    delay2(35);
  }


}



boolean editFill(unsigned char parmIdx){
  unsigned long v = parms[parmIdx];
  long xss,yss;
  unsigned char p=5;  //right end of 10 digit number
  unsigned char keyLock=1;    
  char *fmtv = "0000000000";
  tft.setTextDatum(TL_DATUM);

  /* -- line 1 -- */
  tft.drawString("Top up added to tank", 10, 30, 4);
  tft.drawString("OK   EXIT",166,70,4);
  tft.setTextPadding(16);

  tft.drawString("L",10+(14*(9)),70,4);

  tft.fillRect(   40,190,40,8,TFT_WHITE);
  tft.fillRect(   156,169,8,50,TFT_WHITE);
  tft.fillRect(   240,190,40,8,TFT_WHITE);

  tft.drawLine( 160,150,150,170,TFT_WHITE);
  tft.drawLine( 160,150,151,170,TFT_WHITE);
  tft.drawLine( 160,150,152,170,TFT_WHITE);
  tft.drawLine( 160,150,153,170,TFT_WHITE);
  tft.drawLine( 160,150,154,170,TFT_WHITE);
  tft.drawLine( 160,150,155,170,TFT_WHITE);
  tft.drawLine( 160,150,156,170,TFT_WHITE);
  tft.drawLine( 160,150,157,170,TFT_WHITE);
  tft.drawLine( 160,150,158,170,TFT_WHITE);
  tft.drawLine( 160,150,159,170,TFT_WHITE);
  tft.drawLine( 160,150,160,170,TFT_WHITE);
  tft.drawLine( 160,150,161,170,TFT_WHITE);
  tft.drawLine( 160,150,162,170,TFT_WHITE);
  tft.drawLine( 160,150,163,170,TFT_WHITE);
  tft.drawLine( 160,150,164,170,TFT_WHITE);
  tft.drawLine( 160,150,165,170,TFT_WHITE);
  tft.drawLine( 160,150,166,170,TFT_WHITE);
  tft.drawLine( 160,150,167,170,TFT_WHITE);
  tft.drawLine( 160,150,168,170,TFT_WHITE);
  tft.drawLine( 160,150,169,170,TFT_WHITE);
  tft.drawLine( 160,150,170,170,TFT_WHITE);


  tft.drawLine( 25,194,45,184,TFT_WHITE);
  tft.drawLine( 25,194,45,185,TFT_WHITE);
  tft.drawLine( 25,194,45,186,TFT_WHITE);
  tft.drawLine( 25,194,45,187,TFT_WHITE);
  tft.drawLine( 25,194,45,188,TFT_WHITE);
  tft.drawLine( 25,194,45,189,TFT_WHITE);
  tft.drawLine( 25,194,45,190,TFT_WHITE);
  tft.drawLine( 25,194,45,191,TFT_WHITE);
  tft.drawLine( 25,194,45,192,TFT_WHITE);
  tft.drawLine( 25,194,45,193,TFT_WHITE);
  tft.drawLine( 25,194,45,194,TFT_WHITE);
  tft.drawLine( 25,194,45,195,TFT_WHITE);
  tft.drawLine( 25,194,45,196,TFT_WHITE);
  tft.drawLine( 25,194,45,197,TFT_WHITE);
  tft.drawLine( 25,194,45,198,TFT_WHITE);
  tft.drawLine( 25,194,45,199,TFT_WHITE);
  tft.drawLine( 25,194,45,200,TFT_WHITE);
  tft.drawLine( 25,194,45,201,TFT_WHITE);
  tft.drawLine( 25,194,45,202,TFT_WHITE);
  tft.drawLine( 25,194,45,203,TFT_WHITE);
  tft.drawLine( 25,194,45,204,TFT_WHITE);

  tft.drawLine(275,184,295,194,TFT_WHITE);
  tft.drawLine(275,185,295,194,TFT_WHITE);
  tft.drawLine(275,186,295,194,TFT_WHITE);
  tft.drawLine(275,187,295,194,TFT_WHITE);
  tft.drawLine(275,188,295,194,TFT_WHITE);
  tft.drawLine(275,189,295,194,TFT_WHITE);
  tft.drawLine(275,190,295,194,TFT_WHITE);
  tft.drawLine(275,191,295,194,TFT_WHITE);
  tft.drawLine(275,192,295,194,TFT_WHITE);
  tft.drawLine(275,193,295,194,TFT_WHITE);
  tft.drawLine(275,194,295,194,TFT_WHITE);
  tft.drawLine(275,195,295,194,TFT_WHITE);
  tft.drawLine(275,196,295,194,TFT_WHITE);
  tft.drawLine(275,197,295,194,TFT_WHITE);
  tft.drawLine(275,198,295,194,TFT_WHITE);
  tft.drawLine(275,199,295,194,TFT_WHITE);
  tft.drawLine(275,200,295,194,TFT_WHITE);
  tft.drawLine(275,201,295,194,TFT_WHITE);
  tft.drawLine(275,202,295,194,TFT_WHITE);
  tft.drawLine(275,203,295,194,TFT_WHITE);
  tft.drawLine(275,204,295,194,TFT_WHITE);
  /* -- line 2 -- */
  tft.drawString(fmtv,10,70,4);

  /* -- turn the cursor on -- */
  //   LCD::LcdCommandWrite(LCD_DisplayOnOffCtrl | LCD_DisplayOnOffCtrl_DispOn | LCD_DisplayOnOffCtrl_CursOn);
  /* cursor on 'OK' by default except for contrast */
  // (parmIdx == contrastIdx) ? p=8 : p=10;  

  while(true){

    tft.fillRect(9+(14*(7)),88,3,3,TFT_WHITE); 
    //  tft.fillRect(9+(14*(9)),70,15,21,TFT_BLACK); 
    tft.drawString("L",11+(14*(9)),70,4);

    tft.drawLine(9,91,330,91,TFT_BLACK);
    tft.drawLine(9,92,330,92,TFT_BLACK);
    if (p==10){
      tft.drawLine(165,91,205,91,TFT_BLUE); 
      tft.drawLine(165,92,205,92,TFT_BLUE); 
    }
    else
      if (p==11){
        tft.drawLine(216,91,270,91,TFT_BLUE); 
        tft.drawLine(216,92,270,92,TFT_BLUE); 
      }
    else{
      tft.drawLine(9+(14*(p)),91,9+(14*(p))+15,91,TFT_BLUE); 
      tft.drawLine(9+(14*(p)),92,9+(14*(p))+15,92,TFT_BLUE); 
    }


    tft.setCursor(0, 0);

    myTouch.read();
    xss = myTouch.getX();
    yss = myTouch.getY();
    if (touchorient==0){ 
      xss=320-xss;
      yss=240-yss;
    }

    if (yss>=150){   
      if (xss>=0 && xss<=100){
        cp=cp+1;
        if (cp>=2) {
          p--;
          if(p==255)p=11;
          if(p==9)p=8;
          cp=0;
        }
      };
      if (xss>=110 && xss<=210){
        cp=cp+1;
        if (cp>=2) { 
          {
            ;
            cp=0;
            if(p==10){  //ok selected
              //parms[parmIdx]=rformat(fmtv);
              //   LCD::LcdCommandWrite(B00001100); //cursor off
              tft.fillScreen(TFT_BLACK);
              fueladd=fueladd+rformat(fmtv);
              SCREEN=tempscreen;
              delay2(250);
              return true;
            }
            else if(p==11){  //cancel selected
              //    LCD::LcdCommandWrite(B00001100); //cursor off
              tft.fillScreen(TFT_BLACK);
              SCREEN=tempscreen;
              delay2(250);
              return false;
            }   			 

            unsigned char n = fmtv[p]-'0';
            n++;
            if (n > 9) n=0;
            if(p==0 && n > 3) n=0;
            fmtv[p]='0'+ n;
            //   LCD::gotoXY(0,1);        
            //    LCD::print(fmtv);
            //   LCD::gotoXY(p,1);  
            tft.drawString(fmtv,10,70,4);
          }  
        }
      };
      if (xss>=220 && xss<=318){
        cp=cp+1;
        if (cp>=2) {
          p++;
          if(p==12)p=0;
          if(p==9)p=10;
          cp=0;
        }
      };
    }
    if (xss==-1) cp=0;  
    if (xss==321) cp=0;  







    delay2(35);
  }


}



void filltank(){ //edit all the parameters
  for(int x = 0; x<1; x++) {
    if (!editFill(x)) break;
  }
  save();
  HOLD_DISPLAY=1;
}  

void configtank(){ //edit all the parameters
  for(int x = 0; x<1; x++) {
    if (!configFill(x)) break;
  }
  tank.reset();
  tft.fillScreen(TFT_BLACK);

  tft.setTextColor(TFT_WHITE, TFT_BLACK);

  tft.drawString("TANK RESET",40,100,4);
  tft.drawString("Accuracy Adjusted",40,130,4);
  save();
  HOLD_DISPLAY=1;
}  

void configtankcheck(){ //edit all the parameters
  for(int x = 0; x<1; x++) {
    if (!configFillcheck(x)) break;
  }
  save();
  HOLD_DISPLAY=1;
}  


void initGuino(){ //edit all the parameters
  for(int x = 0; x<mylength(parms); x++) {
    if (!editParm(x)) break;
  }
  save();
  HOLD_DISPLAY=1;
}  

unsigned long millis2(){
  return timer2_overflow_count * 64UL * 2 / (16000000UL / 128000UL);
}

void delay2(unsigned long ms){
  unsigned long start = millis2();
  while (millis2() - start < ms);
}

/* Delay for the given number of microseconds.  Assumes a 16 MHz clock. 
 * Disables interrupts, which will disrupt the millis2() function if used
 * too frequently. */
void delayMicroseconds2(unsigned int us){
  uint8_t oldSREG;
  if (--us == 0)	return;
  us <<= 2;
  us -= 2;
  oldSREG = SREG;
  cli();
  // busy wait
  __asm__ __volatile__ (
  "1: sbiw %0,1" "\n\t" // 2 cycles
"brne 1b" : 
  "=w" (us) : 
  "0" (us) // 2 cycles
    );
  // reenable interrupts.
  SREG = oldSREG;
}

void init2(){
  // this needs to be called before setup() or some functions won't
  // work there
  sei();

  // timer 0 is used for millis2() and delay2()
  timer2_overflow_count = 0;
  // on the ATmega168, timer 0 is also used for fast hardware pwm
  // (using phase-correct PWM would mean that timer 0 overflowed half as often
  // resulting in different millis2() behavior on the ATmega8 and ATmega168)
  TCCR2A=1<<WGM20|1<<WGM21;
  // set timer 2 prescale factor to 64
  TCCR2B=1<<CS22;


  //      TCCR2A=TCCR0A;
  //      TCCR2B=TCCR0B;
  // enable timer 2 overflow interrupt
  TIMSK2|=1<<TOIE2;
  // disable timer 0 overflow interrupt
  TIMSK0&=!(1<<TOIE0);
}




/* ------------------------------------------------------------------ */
#if( SLEEP_CFG == 3 )
void system_sleep() {
  set_sleep_mode(SLEEP_MODE_PWR_DOWN); // sleep mode is set here
  sleep_enable();
  sleep_mode();                        // System sleeps here
  sleep_disable();                     // System continues execution here when watchdog timed out 
}
#endif
/* ------------------------------------------------------------------ */



















